--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.393924923 +0100
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.405774308 +0100
@@ -7036,6 +7879,12 @@
 			if ((ddi_taskq_dispatch(mpt->m_dr_taskq,
 			    mptsas_handle_dr, (void *)topo_head,
 			    DDI_NOSLEEP)) != DDI_SUCCESS) {
+				while (topo_head != NULL) {
+					topo_node = topo_head;
+					topo_head = topo_head->next;
+					kmem_free(topo_node,
+					    sizeof (mptsas_topo_change_list_t));
+				}
 				mptsas_log(mpt, CE_NOTE, "mptsas start taskq "
 				    "for handle SAS DR event failed. \n");
 			}
@@ -7078,7 +7927,8 @@
 	}
 
 	eventreply = (pMpi2EventNotificationReply_t)
-	    (mpt->m_reply_frame + (rfm - mpt->m_reply_frame_dma_addr));
+	    (mpt->m_reply_frame + (rfm -
+	    (mpt->m_reply_frame_dma_addr&0xfffffffful)));
 	event = ddi_get16(mpt->m_acc_reply_frame_hdl, &eventreply->Event);
 
 	if (iocstatus = ddi_get16(mpt->m_acc_reply_frame_hdl,
@@ -7111,10 +7961,10 @@
 		    iocloginfo));
 		break;
 	case MPI2_EVENT_STATE_CHANGE:
-		NDBG20(("mptsas%d state change.", mpt->m_instance));
+		NDBG20(("mptsas3%d state change.", mpt->m_instance));
 		break;
 	case MPI2_EVENT_HARD_RESET_RECEIVED:
-		NDBG20(("mptsas%d event change.", mpt->m_instance));
+		NDBG20(("mptsas3%d event change.", mpt->m_instance));
 		break;
 	case MPI2_EVENT_SAS_DISCOVERY:
 	{
@@ -7151,7 +8001,7 @@
 		break;
 	}
 	case MPI2_EVENT_EVENT_CHANGE:
-		NDBG20(("mptsas%d event change.", mpt->m_instance));
+		NDBG20(("mptsas3%d event change.", mpt->m_instance));
 		break;
 	case MPI2_EVENT_TASK_SET_FULL:
 	{
@@ -7159,7 +8009,7 @@
 
 		taskfull = (pMpi2EventDataTaskSetFull_t)eventreply->EventData;
 
-		NDBG20(("TASK_SET_FULL received for mptsas%d, depth %d\n",
+		NDBG20(("TASK_SET_FULL received for mptsas3%d, depth %d\n",
 		    mpt->m_instance,  ddi_get16(mpt->m_acc_reply_frame_hdl,
 		    &taskfull->CurrentDepth)));
 		break;
@@ -7193,8 +8043,9 @@
 		default:
 		break;
 		}
-		NDBG20(("mptsas%d ENCLOSURE STATUS CHANGE for enclosure %x%s\n",
-		    mpt->m_instance, ddi_get16(mpt->m_acc_reply_frame_hdl,
+		NDBG20(("mptsas3%d ENCLOSURE STATUS CHANGE for enclosure "
+		    "%x%s\n", mpt->m_instance,
+		    ddi_get16(mpt->m_acc_reply_frame_hdl,
 		    &encstatus->EnclosureHandle), string));
 		break;
 	}
@@ -7319,7 +8170,7 @@
 				    rc);
 		}
 
-		NDBG20(("mptsas%d raid operational status: (%s)"
+		NDBG20(("mptsas3%d raid operational status: (%s)"
 		    "\thandle(0x%04x), percent complete(%d)\n",
 		    mpt->m_instance, reason_str, handle, percent));
 		break;
@@ -7388,12 +8239,12 @@
 			    &mpt->m_phy_info[phy_num].smhba_info);
 			break;
 		default:
-			NDBG20(("mptsas%d: unknown BROADCAST PRIMITIVE"
+			NDBG16(("mptsas3%d: unknown BROADCAST PRIMITIVE"
 			    " %x received",
 			    mpt->m_instance, primitive));
 			break;
 		}
-		NDBG20(("mptsas%d sas broadcast primitive: "
+		NDBG16(("mptsas3%d sas broadcast primitive: "
 		    "\tprimitive(0x%04x), phy(%d) complete\n",
 		    mpt->m_instance, primitive, phy_num));
 		break;
@@ -7599,7 +8450,7 @@
 		break;
 	}
 	default:
-		NDBG20(("mptsas%d: unknown event %x received",
+		NDBG20(("mptsas3%d: unknown event %x received",
 		    mpt->m_instance, event));
 		break;
 	}
@@ -7634,23 +8485,85 @@
 
 	for (ptgt = refhash_first(mpt->m_targets); ptgt != NULL;
 	    ptgt = refhash_next(mpt->m_targets, ptgt)) {
+		mutex_enter(&ptgt->m_t_mutex);
 		if (ptgt->m_reset_delay == 0) {
 			if (ptgt->m_t_throttle == QFULL_THROTTLE) {
 				mptsas_set_throttle(mpt, ptgt,
 				    MAX_THROTTLE);
 			}
 		}
+		mutex_exit(&ptgt->m_t_mutex);
 	}
 	mptsas_restart_hba(mpt);
 	mutex_exit(&mpt->m_mutex);
 }
 
+/*
+ * Assume some checks have been done prior to calling this
+ * function so we don't need to consider taking the m_mutex.
+ */
+static void
+mptsas_remove_cmd_nomtx(mptsas_t *mpt, mptsas_cmd_t *cmd)
+{
+	int		slot;
+	mptsas_slots_t	*slots = mpt->m_active;
+	mptsas_target_t	*ptgt = cmd->cmd_tgt_addr;
+
+	ASSERT(cmd != NULL);
+	ASSERT(cmd->cmd_queued == FALSE);
+	ASSERT((cmd->cmd_flags & CFLAG_CMDIOC) == 0);
+
+	slot = cmd->cmd_slot;
+
+	/*
+	 * remove the cmd.
+	 */
+	if (cmd == slots->m_slot[slot]) {
+		NDBG31(("mptsas_remove_cmd_nomtx: removing cmd=0x%p, flags "
+		    "0x%x", (void *)cmd, cmd->cmd_flags));
+		slots->m_slot[slot] = NULL;
+		ASSERT(mpt->m_ncmds != 0);
+		atomic_dec_32(&mpt->m_ncmds);
+		ASSERT(mpt->m_rep_post_queues[cmd->cmd_rpqidx].rpq_ncmds != 0);
+		atomic_dec_32(
+		    &mpt->m_rep_post_queues[cmd->cmd_rpqidx].rpq_ncmds);
+
+		/*
+		 * Decrement per target ncmds, we know this is not an
+		 * IOC cmd and it therefore has a target associated with it.
+		 */
+		mutex_enter(&ptgt->m_t_mutex);
+		ASSERT(ptgt->m_t_ncmds != 0);
+		ptgt->m_t_ncmds--;
+
+		/*
+		 * reset throttle if we just ran an untagged command
+		 * to a tagged target
+		 */
+		if ((ptgt->m_t_ncmds == 0) &&
+		    ((cmd->cmd_pkt_flags & FLAG_TAGMASK) == 0)) {
+			mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
+		}
+
+		/*
+		 * Remove this command from the active queue.
+		 */
+		if (cmd->cmd_active_expiration != 0) {
+			TAILQ_REMOVE(&ptgt->m_active_cmdq, cmd,
+			    cmd_active_link);
+			cmd->cmd_active_expiration = 0;
+		}
+		mutex_exit(&ptgt->m_t_mutex);
+	}
+
+	ASSERT(cmd != slots->m_slot[cmd->cmd_slot]);
+}
+
 void
 mptsas_remove_cmd(mptsas_t *mpt, mptsas_cmd_t *cmd)
 {
 	int		slot;
 	mptsas_slots_t	*slots = mpt->m_active;
-	int		t;
 	mptsas_target_t	*ptgt = cmd->cmd_tgt_addr;
 
 	ASSERT(cmd != NULL);
@@ -7664,23 +8577,30 @@
 		return;
 	}
 
-	t = Tgt(cmd);
 	slot = cmd->cmd_slot;
 
 	/*
 	 * remove the cmd.
 	 */
 	if (cmd == slots->m_slot[slot]) {
-		NDBG31(("mptsas_remove_cmd: removing cmd=0x%p", (void *)cmd));
+		NDBG31(("mptsas_remove_cmd: removing cmd=0x%p, flags 0x%x",
+		    (void *)cmd, cmd->cmd_flags));
 		slots->m_slot[slot] = NULL;
-		mpt->m_ncmds--;
+		ASSERT(mpt->m_ncmds != 0);
+		atomic_dec_32(&mpt->m_ncmds);
+		ASSERT(mpt->m_rep_post_queues[cmd->cmd_rpqidx].rpq_ncmds != 0);
+		atomic_dec_32(
+		    &mpt->m_rep_post_queues[cmd->cmd_rpqidx].rpq_ncmds);
 
 		/*
 		 * only decrement per target ncmds if command
 		 * has a target associated with it.
 		 */
 		if ((cmd->cmd_flags & CFLAG_CMDIOC) == 0) {
+			mutex_enter(&ptgt->m_t_mutex);
+			ASSERT(ptgt->m_t_ncmds != 0);
 			ptgt->m_t_ncmds--;
+
 			/*
 			 * reset throttle if we just ran an untagged command
 			 * to a tagged target
@@ -7689,6 +8609,16 @@
 			    ((cmd->cmd_pkt_flags & FLAG_TAGMASK) == 0)) {
 				mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
 			}
+
+			/*
+			 * Remove this command from the active queue.
+			 */
+			if (cmd->cmd_active_expiration != 0) {
+				TAILQ_REMOVE(&ptgt->m_active_cmdq, cmd,
+				    cmd_active_link);
+				cmd->cmd_active_expiration = 0;
+			}
+			mutex_exit(&ptgt->m_t_mutex);
 		}
 
 	}
@@ -7701,50 +8631,6 @@
 		return;
 	}
 
-	/*
-	 * Figure out what to set tag Q timeout for...
-	 *
-	 * Optimize: If we have duplicate's of same timeout
-	 * we're using, then we'll use it again until we run
-	 * out of duplicates.  This should be the normal case
-	 * for block and raw I/O.
-	 * If no duplicates, we have to scan through tag que and
-	 * find the longest timeout value and use it.  This is
-	 * going to take a while...
-	 * Add 1 to m_n_normal to account for TM request.
-	 */
-	if (cmd->cmd_pkt->pkt_time == ptgt->m_timebase) {
-		if (--(ptgt->m_dups) == 0) {
-			if (ptgt->m_t_ncmds) {
-				mptsas_cmd_t *ssp;
-				uint_t n = 0;
-				ushort_t nslots = (slots->m_n_normal + 1);
-				ushort_t i;
-				/*
-				 * This crude check assumes we don't do
-				 * this too often which seems reasonable
-				 * for block and raw I/O.
-				 */
-				for (i = 0; i < nslots; i++) {
-					ssp = slots->m_slot[i];
-					if (ssp && (Tgt(ssp) == t) &&
-					    (ssp->cmd_pkt->pkt_time > n)) {
-						n = ssp->cmd_pkt->pkt_time;
-						ptgt->m_dups = 1;
-					} else if (ssp && (Tgt(ssp) == t) &&
-					    (ssp->cmd_pkt->pkt_time == n)) {
-						ptgt->m_dups++;
-					}
-				}
-				ptgt->m_timebase = n;
-			} else {
-				ptgt->m_dups = 0;
-				ptgt->m_timebase = 0;
-			}
-		}
-	}
-	ptgt->m_timeout = ptgt->m_timebase;
-
 	ASSERT(cmd != slots->m_slot[cmd->cmd_slot]);
 }
 
@@ -7762,11 +8648,7 @@
 {
 	ASSERT(mutex_owned(&mpt->m_mutex));
 
-	mutex_enter(&mpt->m_tx_waitq_mutex);
-	if (mpt->m_tx_waitq) {
-		mptsas_accept_tx_waitq(mpt);
-	}
-	mutex_exit(&mpt->m_tx_waitq_mutex);
+	mptsas_accept_tx_waitqs(mpt);
 	mptsas_restart_waitq(mpt);
 }
 
@@ -7834,59 +8716,215 @@
 		}
 
 		ptgt = cmd->cmd_tgt_addr;
-		if (ptgt && (ptgt->m_t_throttle == DRAIN_THROTTLE) &&
-		    (ptgt->m_t_ncmds == 0)) {
-			mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
+		if (ptgt) {
+			mutex_enter(&ptgt->m_t_mutex);
+			if ((ptgt->m_t_throttle == DRAIN_THROTTLE) &&
+			    (ptgt->m_t_ncmds == 0)) {
+				mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
+			}
+			if ((mpt->m_ncmds <= (mpt->m_max_requests - 2)) &&
+			    (ptgt->m_reset_delay == 0) &&
+			    (ptgt->m_t_ncmds < ptgt->m_t_throttle)) {
+				mutex_exit(&ptgt->m_t_mutex);
+
+				if (mptsas_save_cmd(mpt, cmd) == TRUE) {
+					mptsas_waitq_delete(mpt, cmd);
+					mutex_exit(&mpt->m_mutex);
+					(void) mptsas_start_cmd(mpt, cmd);
+					mutex_enter(&mpt->m_mutex);
+					cmd = mpt->m_waitq;
+					continue;
+				}
+			} else {
+				mutex_exit(&ptgt->m_t_mutex);
+			}
 		}
-		if ((mpt->m_ncmds <= (mpt->m_max_requests - 2)) &&
-		    (ptgt && (ptgt->m_reset_delay == 0)) &&
-		    (ptgt && (ptgt->m_t_ncmds <
-		    ptgt->m_t_throttle))) {
-			if (mptsas_save_cmd(mpt, cmd) == TRUE) {
-				mptsas_waitq_delete(mpt, cmd);
+		cmd = next_cmd;
+	}
+}
+
+/*
+ * Cmds are queued if scsi_start() doesn't get the m_mutex lock(no wait)
+ * or if the decision has been made to always do that. Setting
+ * mptsas_allow_txq_jumping to zero will allow higher performance on
+ * a heavily loaded system as there is less disruption to the flow here.
+ * There are 2 threads that handle one queue each. The idea is that
+ * they take it in turn to grab the m_mutex to run the mptsas_accept_pkt()
+ * function and then drop it while the cmd is started in mptsas_start_cmd().
+ */
+static void
+mptsas_tx_waitq_thread(mptsas_thread_arg_t *arg)
+{
+	mptsas_t *mpt = arg->mpt;
+	mptsas_tx_waitqueue_t *txwq = &mpt->m_tx_waitq[arg->t];
+
+	mutex_enter(&txwq->txwq_mutex);
+	while (txwq->txwq_active) {
+		mptsas_drain_tx_waitq(mpt, txwq);
+		if (txwq->txwq_wdrain) {
+			cv_signal(&txwq->txwq_drain_cv);
+		}
+		cv_wait(&txwq->txwq_cv, &txwq->txwq_mutex);
+	}
+	mutex_exit(&txwq->txwq_mutex);
+	mutex_enter(&mpt->m_qthread_mutex);
+	mpt->m_txwq_thread_n--;
+	cv_broadcast(&mpt->m_qthread_cv);
+	mutex_exit(&mpt->m_qthread_mutex);
+}
+
+/*
+ * Set the draining flag, disconnect the list and process one at a time
+ * so that the cmds are sent in order.
+ */
+static void
+mptsas_drain_tx_waitq(mptsas_t *mpt, mptsas_tx_waitqueue_t *txwq)
+{
+	mptsas_cmd_t	*cmd, *ncmd;
+	int		rval, start;
+#ifdef MPTSAS_DEBUG
+	uint32_t	qlen;
+#endif
+
+	txwq->txwq_draining = TRUE;
+#ifndef __lock_lint
+	_NOTE(CONSTCOND)
+#endif
+	while (TRUE) {
+
+		/*
+		 * A Bus Reset could occur at any time but it will have to
+		 * wait for the main mutex before flushing the tx_waitq.
+		 * Pull all commands at once, then follow the list in order to
+		 * reduce txwq_mutex hold time. If there is a Bus Reset at
+		 * some point the commands will get to the waitq and then be
+		 * flushed.
+		 */
+		cmd = txwq->txwq_cmdq;
+
+		if (cmd == NULL) {
+			txwq->txwq_draining = FALSE;
+			return;
+		}
+		txwq->txwq_cmdq = NULL;
+		txwq->txwq_qtail = &txwq->txwq_cmdq;
+#ifdef MPTSAS_DEBUG
+		qlen = txwq->txwq_len;
+#endif
+		txwq->txwq_len = 0;
+		mutex_exit(&txwq->txwq_mutex);
+
+		while (cmd) {
+			ncmd = cmd->cmd_linkp;
+			cmd->cmd_linkp = NULL;
+			mutex_enter(&mpt->m_mutex);
+			start = mptsas_accept_pkt(mpt, cmd, &rval);
+			mutex_exit(&mpt->m_mutex);
+			if (start) {
 				(void) mptsas_start_cmd(mpt, cmd);
 			}
+			if (rval != TRAN_ACCEPT)
+				cmn_err(CE_WARN,
+				    "mpt: mptsas_drain_tx_waitq: failed "
+				    "(rval=0x%x) to accept cmd 0x%p on queue\n",
+				    rval, (void *)cmd);
+			cmd = ncmd;
+#ifdef MPTSAS_DEBUG
+			qlen--;
+#endif
 		}
-		cmd = next_cmd;
+		ASSERT(qlen == 0);
+		mutex_enter(&txwq->txwq_mutex);
 	}
 }
+
 /*
- * Cmds are queued if tran_start() doesn't get the m_mutexlock(no wait).
- * Accept all those queued cmds before new cmd is accept so that the
- * cmds are sent in order.
+ * Stop the drain threads from picking up a new list.
+ * Optionally wait for the current list being processed to drain through.
+ * Add to and processing the tx waitq is now on hold until unblock is called.
  */
 static void
-mptsas_accept_tx_waitq(mptsas_t *mpt)
+mptsas_block_tx_waitqs(mptsas_t *mpt, int wait)
 {
-	mptsas_cmd_t *cmd;
+	int		i;
+	uint8_t		wdrain = 0;
+	mptsas_tx_waitqueue_t *txwq;
 
 	ASSERT(mutex_owned(&mpt->m_mutex));
-	ASSERT(mutex_owned(&mpt->m_tx_waitq_mutex));
+
+	if (mpt->m_txwq_thread_n == 0) {
+		return;
+	}
 
 	/*
-	 * A Bus Reset could occur at any time and flush the tx_waitq,
-	 * so we cannot count on the tx_waitq to contain even one cmd.
-	 * And when the m_tx_waitq_mutex is released and run
-	 * mptsas_accept_pkt(), the tx_waitq may be flushed.
+	 * Turn off the use of the tx wait queues by scsi_start().
+	 * This is just a dynamic flag no need for a mutex.
 	 */
-	cmd = mpt->m_tx_waitq;
-	for (;;) {
-		if ((cmd = mpt->m_tx_waitq) == NULL) {
-			mpt->m_tx_draining = 0;
-			break;
-		}
-		if ((mpt->m_tx_waitq = cmd->cmd_linkp) == NULL) {
-			mpt->m_tx_waitqtail = &mpt->m_tx_waitq;
+	mpt->m_txwq_enabled = BLOCKED;
+
+	for (i = 0; i < NUM_TX_WAITQ; i++) {
+		txwq = &mpt->m_tx_waitq[i];
+		mutex_enter(&txwq->txwq_mutex);
+		txwq->txwq_wdrain = TRUE;
+		if (txwq->txwq_draining && wait)
+			wdrain |= (1<<i);
+		mutex_exit(&txwq->txwq_mutex);
+	}
+
+	if (wdrain) {
+		/*
+		 * Because the threads disconnect the entire queue each time
+		 * round in order to drain to completely drain we have to
+		 * drop the main mutex otherwise the drain threads get stuck.
+		 */
+		mutex_exit(&mpt->m_mutex);
+		for (i = 0; i < NUM_TX_WAITQ; i++) {
+			if (wdrain & (1<<i)) {
+				txwq = &mpt->m_tx_waitq[i];
+				mutex_enter(&txwq->txwq_mutex);
+				while (txwq->txwq_draining) {
+					cv_wait(&txwq->txwq_drain_cv,
+					    &txwq->txwq_mutex);
+				}
+				mutex_exit(&txwq->txwq_mutex);
+			}
 		}
-		cmd->cmd_linkp = NULL;
-		mutex_exit(&mpt->m_tx_waitq_mutex);
-		if (mptsas_accept_pkt(mpt, cmd) != TRAN_ACCEPT)
-			cmn_err(CE_WARN, "mpt: mptsas_accept_tx_waitq: failed "
-			    "to accept cmd on queue\n");
-		mutex_enter(&mpt->m_tx_waitq_mutex);
+		mutex_enter(&mpt->m_mutex);
 	}
 }
 
+static void
+mptsas_unblock_tx_waitqs(mptsas_t *mpt)
+{
+	int			i;
+	mptsas_tx_waitqueue_t	*txwq;
+
+	if (mpt->m_txwq_thread_n == 0) {
+		return;
+	}
+
+	for (i = 0; i < NUM_TX_WAITQ; i++) {
+		txwq = &mpt->m_tx_waitq[i];
+		mutex_enter(&txwq->txwq_mutex);
+		txwq->txwq_wdrain = FALSE;
+		cv_signal(&txwq->txwq_cv);
+		mutex_exit(&txwq->txwq_mutex);
+	}
+
+	mpt->m_txwq_enabled = FALSE;
+}
+
+static void
+mptsas_accept_tx_waitqs(mptsas_t *mpt)
+{
+	/*
+	 * Block with drain and unblock will leave us in a state where
+	 * we have the main mutex, there is nothing on the tx wait queues
+	 * and they are not in use until watch notices high activity again.
+	 */
+	mptsas_block_tx_waitqs(mpt, 1);
+	mptsas_unblock_tx_waitqs(mpt);
+}
 
 /*
  * mpt tag type lookup
@@ -7899,22 +8937,26 @@
 {
 	struct scsi_pkt		*pkt = CMD2PKT(cmd);
 	uint32_t		control = 0;
-	int			n;
-	caddr_t			mem;
+	caddr_t			mem, arsbuf;
 	pMpi2SCSIIORequest_t	io_request;
 	ddi_dma_handle_t	dma_hdl = mpt->m_dma_req_frame_hdl;
 	ddi_acc_handle_t	acc_hdl = mpt->m_acc_req_frame_hdl;
 	mptsas_target_t		*ptgt = cmd->cmd_tgt_addr;
-	uint16_t		SMID, io_flags = 0;
-	uint32_t		request_desc_low, request_desc_high;
+	uint16_t		SMID, io_flags = 0, ars_size;
+	uint8_t			MSIidx;
+	uint64_t		request_desc;
+	uint32_t		ars_dmaaddrlow;
+	mptsas_cmd_t		*c;
 
-	NDBG1(("mptsas_start_cmd: cmd=0x%p", (void *)cmd));
+	NDBG1(("mptsas_start_cmd: cmd=0x%p, flags 0x%x", (void *)cmd,
+	    cmd->cmd_flags));
 
 	/*
 	 * Set SMID and increment index.  Rollover to 1 instead of 0 if index
 	 * is at the max.  0 is an invalid SMID, so we call the first index 1.
 	 */
 	SMID = cmd->cmd_slot;
+	MSIidx = cmd->cmd_rpqidx;
 
 	/*
 	 * It is possible for back to back device reset to
@@ -7930,6 +8972,7 @@
 	 * then drain before submitting this cmd; SCSI-2 allows RQSENSE
 	 * to be untagged
 	 */
+	mutex_enter(&ptgt->m_t_mutex);
 	if (((cmd->cmd_pkt_flags & FLAG_TAGMASK) == 0) &&
 	    (ptgt->m_t_ncmds > 1) &&
 	    ((cmd->cmd_flags & CFLAG_TM_CMD) == 0) &&
@@ -7941,10 +8984,15 @@
 			if (ptgt->m_reset_delay == 0) {
 				mptsas_set_throttle(mpt, ptgt, DRAIN_THROTTLE);
 			}
+			mutex_exit(&ptgt->m_t_mutex);
 
+			mutex_enter(&mpt->m_mutex);
 			mptsas_remove_cmd(mpt, cmd);
 			cmd->cmd_pkt_flags |= FLAG_HEAD;
 			mptsas_waitq_add(mpt, cmd);
+			mutex_exit(&mpt->m_mutex);
+		} else {
+			mutex_exit(&ptgt->m_t_mutex);
 		}
 		return (DDI_FAILURE);
 	}
@@ -7975,14 +9023,71 @@
 		control |= MPI2_SCSIIO_CONTROL_SIMPLEQ;
 	}
 
+	/*
+	 * Set timeout.
+	 */
+	cmd->cmd_active_expiration =
+	    gethrtime() + (hrtime_t)pkt->pkt_time * NANOSEC;
+
+	c = TAILQ_FIRST(&ptgt->m_active_cmdq);
+	if (c == NULL ||
+	    c->cmd_active_expiration < cmd->cmd_active_expiration) {
+		/*
+		 * Common case is that this is the last pending expiration
+		 * (or queue is empty). Insert at head of the queue.
+		 */
+		TAILQ_INSERT_HEAD(&ptgt->m_active_cmdq, cmd, cmd_active_link);
+	} else {
+		/*
+		 * Queue is not empty and first element expires later than
+		 * this command. Search for element expiring sooner.
+		 */
+		while ((c = TAILQ_NEXT(c, cmd_active_link)) != NULL) {
+			if (c->cmd_active_expiration <
+			    cmd->cmd_active_expiration) {
+				TAILQ_INSERT_BEFORE(c, cmd, cmd_active_link);
+				break;
+			}
+		}
+		if (c == NULL) {
+			/*
+			 * No element found expiring sooner, append to
+			 * non-empty queue.
+			 */
+			TAILQ_INSERT_TAIL(&ptgt->m_active_cmdq, cmd,
+			    cmd_active_link);
+		}
+	}
+
+	mutex_exit(&ptgt->m_t_mutex);
+
 	if (cmd->cmd_pkt_flags & FLAG_TLR) {
 		control |= MPI2_SCSIIO_CONTROL_TLR_ON;
 	}
 
 	mem = mpt->m_req_frame + (mpt->m_req_frame_size * SMID);
 	io_request = (pMpi2SCSIIORequest_t)mem;
-
+	if (cmd->cmd_extrqslen != 0) {
+		/*
+		 * Mapping of the buffer was done in mptsas_pkt_alloc_extern().
+		 * Calculate the DMA address with the same offset.
+		 */
+		arsbuf = cmd->cmd_arq_buf;
+		ars_size = cmd->cmd_extrqslen;
+		ars_dmaaddrlow = (mpt->m_req_sense_dma_addr +
+		    ((uintptr_t)arsbuf - (uintptr_t)mpt->m_req_sense)) &
+		    0xffffffffull;
+	} else {
+		arsbuf = mpt->m_req_sense + (mpt->m_req_sense_size * (SMID-1));
+		cmd->cmd_arq_buf = arsbuf;
+		ars_size = mpt->m_req_sense_size;
+		ars_dmaaddrlow = (mpt->m_req_sense_dma_addr +
+		    (mpt->m_req_sense_size * (SMID-1))) &
+		    0xffffffffull;
+	}
 	bzero(io_request, sizeof (Mpi2SCSIIORequest_t));
+	bzero(arsbuf, ars_size);
+
 	ddi_put8(acc_hdl, &io_request->SGLOffset0, offsetof
 	    (MPI2_SCSI_IO_REQUEST, SGL) / 4);
 	mptsas_init_std_hdr(acc_hdl, io_request, ptgt->m_devhdl, Lun(cmd), 0,
@@ -7992,6 +9097,13 @@
 	    io_request->CDB.CDB32, cmd->cmd_cdblen, DDI_DEV_AUTOINCR);
 
 	io_flags = cmd->cmd_cdblen;
+	if (mptsas3_use_fastpath &&
+	    ptgt->m_io_flags & MPI25_SAS_DEVICE0_FLAGS_ENABLED_FAST_PATH) {
+		io_flags |= MPI25_SCSIIO_IOFLAGS_FAST_PATH;
+		request_desc = MPI25_REQ_DESCRIPT_FLAGS_FAST_PATH_SCSI_IO;
+	} else {
+		request_desc = MPI2_REQ_DESCRIPT_FLAGS_SCSI_IO;
+	}
 	ddi_put16(acc_hdl, &io_request->IoFlags, io_flags);
 	/*
 	 * setup the Scatter/Gather DMA list for this request
@@ -8010,127 +9122,107 @@
 	 * save ARQ information
 	 */
 	ddi_put8(acc_hdl, &io_request->SenseBufferLength, cmd->cmd_rqslen);
-	if ((cmd->cmd_flags & (CFLAG_SCBEXTERN | CFLAG_EXTARQBUFVALID)) ==
-	    (CFLAG_SCBEXTERN | CFLAG_EXTARQBUFVALID)) {
-		ddi_put32(acc_hdl, &io_request->SenseBufferLowAddress,
-		    cmd->cmd_ext_arqcookie.dmac_address);
-	} else {
-		ddi_put32(acc_hdl, &io_request->SenseBufferLowAddress,
-		    cmd->cmd_arqcookie.dmac_address);
-	}
+	ddi_put32(acc_hdl, &io_request->SenseBufferLowAddress, ars_dmaaddrlow);
 
 	ddi_put32(acc_hdl, &io_request->Control, control);
 
-	NDBG31(("starting message=0x%p, with cmd=0x%p",
-	    (void *)(uintptr_t)mpt->m_req_frame_dma_addr, (void *)cmd));
+	NDBG31(("starting message=%d(0x%p), with cmd=0x%p",
+	    SMID, (void *)io_request, (void *)cmd));
 
 	(void) ddi_dma_sync(dma_hdl, 0, 0, DDI_DMA_SYNC_FORDEV);
 
 	/*
 	 * Build request descriptor and write it to the request desc post reg.
 	 */
-	request_desc_low = (SMID << 16) + MPI2_REQ_DESCRIPT_FLAGS_SCSI_IO;
-	request_desc_high = ptgt->m_devhdl << 16;
-	MPTSAS_START_CMD(mpt, request_desc_low, request_desc_high);
-
-	/*
-	 * Start timeout.
-	 */
-#ifdef MPTSAS_TEST
-	/*
-	 * Temporarily set timebase = 0;  needed for
-	 * timeout torture test.
-	 */
-	if (mptsas_test_timeouts) {
-		ptgt->m_timebase = 0;
-	}
-#endif
-	n = pkt->pkt_time - ptgt->m_timebase;
-
-	if (n == 0) {
-		(ptgt->m_dups)++;
-		ptgt->m_timeout = ptgt->m_timebase;
-	} else if (n > 0) {
-		ptgt->m_timeout =
-		    ptgt->m_timebase = pkt->pkt_time;
-		ptgt->m_dups = 1;
-	} else if (n < 0) {
-		ptgt->m_timeout = ptgt->m_timebase;
-	}
-#ifdef MPTSAS_TEST
-	/*
-	 * Set back to a number higher than
-	 * mptsas_scsi_watchdog_tick
-	 * so timeouts will happen in mptsas_watchsubr
-	 */
-	if (mptsas_test_timeouts) {
-		ptgt->m_timebase = 60;
-	}
-#endif
+	request_desc |= (SMID << 16) + (MSIidx << 8);
+	request_desc |= ((uint64_t)ptgt->m_devhdl << 48);
+	MPTSAS_START_CMD(mpt, request_desc);
 
+#if 0
+	/* Is this of any benefit here, what is it going to catch? */
 	if ((mptsas_check_dma_handle(dma_hdl) != DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(acc_hdl) != DDI_SUCCESS)) {
 		ddi_fm_service_impact(mpt->m_dip, DDI_SERVICE_UNAFFECTED);
 		return (DDI_FAILURE);
 	}
+#endif
 	return (DDI_SUCCESS);
 }
 
 /*
- * Select a helper thread to handle current doneq
+ * Select a helper thread to handle given doneq.
+ * Note that we don't require to have the main m_mutex here, but worst case
+ * is that we wont follow the thread rotation to the letter.
+ * However must ensure we have the mutex that covers the source dlist when
+ * we actually hand off.
  */
 static void
-mptsas_deliver_doneq_thread(mptsas_t *mpt)
+mptsas_deliver_doneq_thread(mptsas_t *mpt, mptsas_done_list_t *dlist)
 {
-	uint64_t			t, i;
+	uint32_t			t, i, j = mpt->m_doneq_next_thread;
 	uint32_t			min = 0xffffffff;
 	mptsas_doneq_thread_list_t	*item;
 
+	/*
+	 * No need to take indivudual list mutex's during the loop.
+	 * We are only reading values and the worst that will happen is that
+	 * we pick the wrong thread.
+	 */
 	for (i = 0; i < mpt->m_doneq_thread_n; i++) {
-		item = &mpt->m_doneq_thread_id[i];
+		item = &mpt->m_doneq_thread_id[j];
+
 		/*
 		 * If the completed command on help thread[i] less than
-		 * doneq_thread_threshold, then pick the thread[i]. Otherwise
+		 * doneq_thread_threshold, then pick the thread[j]. Otherwise
 		 * pick a thread which has least completed command.
 		 */
-
-		mutex_enter(&item->mutex);
-		if (item->len < mpt->m_doneq_thread_threshold) {
-			t = i;
-			mutex_exit(&item->mutex);
+		if (item->dlist.dl_len < mpt->m_doneq_thread_threshold) {
+			t = j;
 			break;
 		}
-		if (item->len < min) {
-			min = item->len;
-			t = i;
+		if (item->dlist.dl_len < min) {
+			min = item->dlist.dl_len;
+			t = j;
 		}
-		mutex_exit(&item->mutex);
+		if (++j == mpt->m_doneq_thread_n) {
+			j = 0;
+		}
+	}
+	item = &mpt->m_doneq_thread_id[t];
+	mutex_enter(&item->mutex);
+	mptsas_doneq_mv(dlist, item);
+	cv_signal(&item->cv);
+	mutex_exit(&item->mutex);
+
+	/*
+	 * Next time start at the next thread.
+	 * This will minimize the potential of grabing a lock
+	 * for a thread that is busy, either on a very busy systems
+	 * or on one that is configured to do all command completion
+	 * processing through threads.
+	 */
+	if (++t == mpt->m_doneq_thread_n) {
+		t = 0;
 	}
-	mutex_enter(&mpt->m_doneq_thread_id[t].mutex);
-	mptsas_doneq_mv(mpt, t);
-	cv_signal(&mpt->m_doneq_thread_id[t].cv);
-	mutex_exit(&mpt->m_doneq_thread_id[t].mutex);
+	mpt->m_doneq_next_thread = (uint16_t)t;
 }
 
 /*
- * move the current global doneq to the doneq of thead[t]
+ * move one doneq to another.
  */
 static void
-mptsas_doneq_mv(mptsas_t *mpt, uint64_t t)
+mptsas_doneq_mv(mptsas_done_list_t *from, mptsas_doneq_thread_list_t *item)
 {
+	mptsas_done_list_t		*to = &item->dlist;
 	mptsas_cmd_t			*cmd;
-	mptsas_doneq_thread_list_t	*item = &mpt->m_doneq_thread_id[t];
 
-	ASSERT(mutex_owned(&item->mutex));
-	while ((cmd = mpt->m_doneq) != NULL) {
-		if ((mpt->m_doneq = cmd->cmd_linkp) == NULL) {
-			mpt->m_donetail = &mpt->m_doneq;
-		}
-		cmd->cmd_linkp = NULL;
-		*item->donetail = cmd;
-		item->donetail = &cmd->cmd_linkp;
-		mpt->m_doneq_len--;
-		item->len++;
+	if ((cmd = from->dl_q) != NULL) {
+		*to->dl_tail = cmd;
+		to->dl_tail = from->dl_tail;
+		to->dl_len += from->dl_len;
+		from->dl_q = NULL;
+		from->dl_tail = &from->dl_q;
+		from->dl_len = 0;
 	}
 }
 
@@ -8144,6 +9236,8 @@
 	    DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_req_frame_hdl) !=
 	    DDI_SUCCESS) ||
+	    (mptsas_check_acc_handle(mpt->m_acc_req_sense_hdl) !=
+	    DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_reply_frame_hdl) !=
 	    DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_free_queue_hdl) !=
@@ -8163,6 +9257,8 @@
 	}
 	if ((mptsas_check_dma_handle(mpt->m_dma_req_frame_hdl) !=
 	    DDI_SUCCESS) ||
+	    (mptsas_check_dma_handle(mpt->m_dma_req_sense_hdl) !=
+	    DDI_SUCCESS) ||
 	    (mptsas_check_dma_handle(mpt->m_dma_reply_frame_hdl) !=
 	    DDI_SUCCESS) ||
 	    (mptsas_check_dma_handle(mpt->m_dma_free_queue_hdl) !=
@@ -8191,18 +9287,6 @@
 		pkt->pkt_reason = CMD_TRAN_ERR;
 		pkt->pkt_statistics = 0;
 	}
-	if (cmd->cmd_arqhandle &&
-	    (mptsas_check_dma_handle(cmd->cmd_arqhandle) != DDI_SUCCESS)) {
-		ddi_fm_service_impact(mpt->m_dip, DDI_SERVICE_UNAFFECTED);
-		pkt->pkt_reason = CMD_TRAN_ERR;
-		pkt->pkt_statistics = 0;
-	}
-	if (cmd->cmd_ext_arqhandle &&
-	    (mptsas_check_dma_handle(cmd->cmd_ext_arqhandle) != DDI_SUCCESS)) {
-		ddi_fm_service_impact(mpt->m_dip, DDI_SERVICE_UNAFFECTED);
-		pkt->pkt_reason = CMD_TRAN_ERR;
-		pkt->pkt_statistics = 0;
-	}
 }
 
 /*
@@ -8233,9 +9317,35 @@
 	 * the doneq.  no intr cmds do not have callbacks.
 	 */
 	if (pkt && (pkt->pkt_comp)) {
-		*mpt->m_donetail = cmd;
-		mpt->m_donetail = &cmd->cmd_linkp;
-		mpt->m_doneq_len++;
+		*mpt->m_dlist.dl_tail = cmd;
+		mpt->m_dlist.dl_tail = &cmd->cmd_linkp;
+		mpt->m_dlist.dl_len++;
+	}
+}
+
+static void
+mptsas_rpdoneq_add(mptsas_t *mpt, mptsas_reply_pqueue_t *rpqp,
+    mptsas_cmd_t *cmd)
+{
+	struct scsi_pkt	*pkt = CMD2PKT(cmd);
+
+	NDBG31(("mptsas_rpdoneq_add: cmd=0x%p", (void *)cmd));
+
+	ASSERT((cmd->cmd_flags & CFLAG_COMPLETED) == 0);
+	cmd->cmd_linkp = NULL;
+	cmd->cmd_flags |= CFLAG_FINISHED;
+	cmd->cmd_flags &= ~CFLAG_IN_TRANSPORT;
+
+	mptsas_fma_check(mpt, cmd);
+
+	/*
+	 * only add scsi pkts that have completion routines to
+	 * the doneq.  no intr cmds do not have callbacks.
+	 */
+	if (pkt && (pkt->pkt_comp)) {
+		*rpqp->rpq_dlist.dl_tail = cmd;
+		rpqp->rpq_dlist.dl_tail = &cmd->cmd_linkp;
+		rpqp->rpq_dlist.dl_len++;
 	}
 }
 
@@ -8246,14 +9356,14 @@
 	mptsas_doneq_thread_list_t	*item = &mpt->m_doneq_thread_id[t];
 
 	/* pop one off the done queue */
-	if ((cmd = item->doneq) != NULL) {
+	if ((cmd = item->dlist.dl_q) != NULL) {
 		/* if the queue is now empty fix the tail pointer */
 		NDBG31(("mptsas_doneq_thread_rm: cmd=0x%p", (void *)cmd));
-		if ((item->doneq = cmd->cmd_linkp) == NULL) {
-			item->donetail = &item->doneq;
+		if ((item->dlist.dl_q = cmd->cmd_linkp) == NULL) {
+			item->dlist.dl_tail = &item->dlist.dl_q;
 		}
 		cmd->cmd_linkp = NULL;
-		item->len--;
+		item->dlist.dl_len--;
 	}
 	return (cmd);
 }
@@ -8261,15 +9371,14 @@
 static void
 mptsas_doneq_empty(mptsas_t *mpt)
 {
-	if (mpt->m_doneq && !mpt->m_in_callback) {
+	if (mpt->m_dlist.dl_q) {
 		mptsas_cmd_t	*cmd, *next;
 		struct scsi_pkt *pkt;
 
-		mpt->m_in_callback = 1;
-		cmd = mpt->m_doneq;
-		mpt->m_doneq = NULL;
-		mpt->m_donetail = &mpt->m_doneq;
-		mpt->m_doneq_len = 0;
+		cmd = mpt->m_dlist.dl_q;
+		mpt->m_dlist.dl_q = NULL;
+		mpt->m_dlist.dl_tail = &mpt->m_dlist.dl_q;
+		mpt->m_dlist.dl_len = 0;
 
 		mutex_exit(&mpt->m_mutex);
 		/*
@@ -8286,7 +9395,36 @@
 			cmd = next;
 		}
 		mutex_enter(&mpt->m_mutex);
-		mpt->m_in_callback = 0;
+	}
+}
+
+static void
+mptsas_rpdoneq_empty(mptsas_reply_pqueue_t *rpqp)
+{
+	if (rpqp->rpq_dlist.dl_q) {
+		mptsas_cmd_t	*cmd, *next;
+		struct scsi_pkt *pkt;
+
+		cmd = rpqp->rpq_dlist.dl_q;
+		rpqp->rpq_dlist.dl_q = NULL;
+		rpqp->rpq_dlist.dl_tail = &rpqp->rpq_dlist.dl_q;
+		rpqp->rpq_dlist.dl_len = 0;
+
+		mutex_exit(&rpqp->rpq_mutex);
+		/*
+		 * run the completion routines of all the
+		 * completed commands
+		 */
+		while (cmd != NULL) {
+			next = cmd->cmd_linkp;
+			cmd->cmd_linkp = NULL;
+			/* run this command's completion routine */
+			cmd->cmd_flags |= CFLAG_COMPLETED;
+			pkt = CMD2PKT(cmd);
+			mptsas_pkt_comp(pkt, cmd);
+			cmd = next;
+		}
+		mutex_enter(&rpqp->rpq_mutex);
 	}
 }
 
@@ -8376,57 +9514,6 @@
 	cmn_err(CE_PANIC, "mpt: mptsas_waitq_delete: queue botch");
 }
 
-static mptsas_cmd_t *
-mptsas_tx_waitq_rm(mptsas_t *mpt)
-{
-	mptsas_cmd_t *cmd;
-	NDBG7(("mptsas_tx_waitq_rm"));
-
-	MPTSAS_TX_WAITQ_RM(mpt, cmd);
-
-	NDBG7(("mptsas_tx_waitq_rm: cmd=0x%p", (void *)cmd));
-
-	return (cmd);
-}
-
-/*
- * remove specified cmd from the middle of the tx_waitq.
- */
-static void
-mptsas_tx_waitq_delete(mptsas_t *mpt, mptsas_cmd_t *cmd)
-{
-	mptsas_cmd_t *prevp = mpt->m_tx_waitq;
-
-	NDBG7(("mptsas_tx_waitq_delete: mpt=0x%p cmd=0x%p",
-	    (void *)mpt, (void *)cmd));
-
-	if (prevp == cmd) {
-		if ((mpt->m_tx_waitq = cmd->cmd_linkp) == NULL)
-			mpt->m_tx_waitqtail = &mpt->m_tx_waitq;
-
-		cmd->cmd_linkp = NULL;
-		cmd->cmd_queued = FALSE;
-		NDBG7(("mptsas_tx_waitq_delete: mpt=0x%p cmd=0x%p",
-		    (void *)mpt, (void *)cmd));
-		return;
-	}
-
-	while (prevp != NULL) {
-		if (prevp->cmd_linkp == cmd) {
-			if ((prevp->cmd_linkp = cmd->cmd_linkp) == NULL)
-				mpt->m_tx_waitqtail = &prevp->cmd_linkp;
-
-			cmd->cmd_linkp = NULL;
-			cmd->cmd_queued = FALSE;
-			NDBG7(("mptsas_tx_waitq_delete: mpt=0x%p cmd=0x%p",
-			    (void *)mpt, (void *)cmd));
-			return;
-		}
-		prevp = prevp->cmd_linkp;
-	}
-	cmn_err(CE_PANIC, "mpt: mptsas_tx_waitq_delete: queue botch");
-}
-
 /*
  * device and bus reset handling
  *
@@ -8542,7 +9629,7 @@
 	return (mptsas_get_name(sd, name, len));
 }
 
-void
+static void
 mptsas_set_throttle(mptsas_t *mpt, mptsas_target_t *ptgt, int what)
 {
 
